﻿using System;
using System.Data;
using System.Linq;
using System.Windows.Forms;

namespace LINQ_To_SQL_TEST
{
    public partial class Form1 : Form
    {
        ContactModelDataContext context = new ContactModelDataContext();
        public int id;

        public Form1()
        {
            InitializeComponent();
        }
       
        private void Form1_Load(object sender, EventArgs e)
        {
           
        }
        public void RefreshData()
        {
            IQueryable<Contact> allData = context.Contacts.Select(x => x);
            dataGridView1.DataSource = allData;
        }

        private void btnLoadData_Click(object sender, EventArgs e)
        {
            //---------------SELECT---------------------//
            RefreshData();
            ClearText();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            //------------DELETE-------------------
            int id = int.Parse(dataGridView1.CurrentRow.Cells["ID"].Value.ToString());
            var query = context.Contacts.Where(x => x.ID == id).FirstOrDefault();
            context.Contacts.DeleteOnSubmit(query);
            context.SubmitChanges();
            RefreshData();
            ClearText();
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            //------------------INSERT----------------------
            string fname = txtName.Text;
            string lname = txtLastname.Text;
            string email = txtEmail.Text;
            string Number = txtNumber.Text;
            string address = txtAddress.Text;
            DateTime date = dateTimePicker1.Value;
            Contact obj = new Contact() { Name = fname, Lastname = lname, Email = email, MobileNumber = Number, Address = address, birthday = date};
            context.Contacts.InsertOnSubmit(obj);
            context.SubmitChanges();
            RefreshData();
            ClearText();
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {      
            //--------------UPDATE------------------------------
            string fname = txtName.Text;
            string lname = txtLastname.Text;
            string email = txtEmail.Text;
            string Number = txtNumber.Text;
            string address = txtAddress.Text;
            DateTime date = dateTimePicker1.Value;
            var obj = context.Contacts.Where(x => x.ID == id).FirstOrDefault();
            obj.Name = fname;
            obj.Lastname = lname;
            obj.MobileNumber = Number;
            obj.Address = address;
            obj.birthday = date;
            obj.Email = email;
            context.SubmitChanges();
            ClearText();
        }

        private void dataGridView1_Click(object sender, EventArgs e)
        {
            txtName.Text = dataGridView1.CurrentRow.Cells["Name"].Value.ToString();
            txtLastname.Text = dataGridView1.CurrentRow.Cells["Lastname"].Value.ToString();
            txtEmail.Text = dataGridView1.CurrentRow.Cells["Email"].Value.ToString();
            txtNumber.Text = dataGridView1.CurrentRow.Cells["Mobilenumber"].Value.ToString();
            txtAddress.Text = dataGridView1.CurrentRow.Cells["Address"].Value.ToString();
            DateTime date = (DateTime) dataGridView1.CurrentRow.Cells["birthday"].Value;
            dateTimePicker1.Value = date;
            id = int.Parse(dataGridView1.CurrentRow.Cells["ID"].Value.ToString());

        }
        public void ClearText()
        {
            foreach (var item in this.Controls)
            {
                if (item.GetType() == txtAddress.GetType())
                {
                    TextBox box = (TextBox)item;
                    box.Clear();
                }
            }
        }

    }
}
